//+------------------------------------------------------------------+
//|                                 KG Daily Cross Trading Method EA |
//|                                                    Steve Hopwood |
//|                                     www.hopwood3,freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Steve Hopwood"
#property link      "www.hopwood3,freeserve.co.uk"
#property copyright "Copyright  2008, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#include <LibOrderReliable.mqh>
#define  NL    "\n"

/*
int start()
void DisplayUserFeedback()
void SetUpGlobalVariables()
void CheckForCrosses()
bool IsThisPairExcluded(string symbol)
void CheckForReCrosses()
bool CheckRecrossOnLowerTf(string T1, string T2, int TimeFrame, int type)
void CompareTriggerStrengths(string T1, string T2)
void PrepareTradePlacement()
bool TakeLongDcTrade(string symbol, int type)
bool TakeShortDcTrade(string symbol, int type)
void SetUpCrossesDisplay()
bool CheckLowerTimeFrames(string symbol, int GvVal)
bool CheckIndividualLowerTF(string symbol, int GvVal, int TfVal)
bool CheckDcTrade(string symbol, bool TradeAllowed, string BasketType)
bool HaveBarsPassed(string symbol)
void DcGlobalOrderClosure()
bool CloseDcTrades(MagicNumber)
bool CheckTriggerGapSize(symbol)
bool ReturnSpreadDecision(string symbol)
double ReadStochastic(string symbol)
bool DoesTradeExist(string symbol)
void CheckPendingTradeEntryLevel()
bool ReadMACD(int type, string symbol)
bool ShamusFamousFilter(int type, string symbol)

void MonitorTrades()
void ManageTrade()
void BreakEvenStopLoss()
bool PartCloseTradeFunction()
void JumpingStopLoss() 
void TrailingStopLoss()
void InstantTrailingStopLoss()
void SetAGlobalTicketVariable()
int GetNextAvailableVariableNumber()

*/

extern bool       TradeKgMethod=false;
extern bool       TradeSaharsMethod=true;
extern int        SaharsPendingDistancePips=10;
extern int        SaharsPendingTimeLimitHours=12;
extern bool       TradeGBP=true;
extern bool       TradeJPY=true;
extern bool       TradeUSD=true;
extern bool       TradeEUR=true;
extern bool       TradeCHF=true;
extern bool       TradeAUD=true;
extern bool       TradeNZD=true;
extern bool       TradeCAD=false;
extern int        MinGapBetweenTriggers=5;
extern bool       CloseDcTradesOnRecross=true;
extern double     CloseDcTradesOnRecrossPoints=20;
extern int        CloseDcLowerTimeFrameFilter1=240;
extern int        CloseDcLowerTimeFrameFilter2=60;
extern bool       BrokerIs2stageCrook=false;
extern int        DcStopLoss=0;
extern bool       AutoDcCalcStopLoss=true;
extern int        MinStopLoss=200;
extern int        DcTakeProfit=0;
extern bool       AutoCalculateTakeProfit=true;
extern double     AtrPeriod=20;
extern int        AdxPeriod=14;
extern int        LowerTimeFrameFilter1=240;
extern int        LowerTimeFrameFilter2=60;
extern int        LowerTimeFrameFilter3=0;
extern int        LowerTimeFrameFilter4=0;
extern int        DcMagicNumber=427851;
extern string     DailyCrossTradeComment="Daily Cross";
extern bool       OverrideMaxTradesAllowed=false;
extern int        No_Trade_For_X_Bars = 2;
extern string     b21="---------------------------------------------------------------------";
extern string     tf="Individual trade filters";
extern string     so="Stochastic";   
extern bool       UseStochasticFilter=true;
extern double     StochOverBought=80;
extern double     StochOverSold=20;
extern string     mac="MACD";
extern bool       UseMACD=false;
extern int        MacdPeriod=1440;
extern int        MacdLookBackBars=3;
extern string     shms="ShamusFamous";
extern bool       UseShamusFamous=true;
extern string     b22="---------------------------------------------------------------------";
extern string     itf="Immediate entry settings";
extern bool       ImmediateAlertOnCross=false;
extern bool       ImmediateEntryOnCross=false;
extern string     ins50="DC trade management settings";
extern bool       EaManagesTrades=true;
extern string     slf="--DC Stop Loss & Take Profit Manipulation----";
extern string     BE="Break even settings";
extern bool       BreakEven=false;
extern int        BreakEvenPips=200;
extern int        BreakEvenProfit=10;
extern string     JSL="Jumping stop loss settings";
extern bool       JumpingStop=false;
extern int        JumpingStopPips=200;
extern bool       AddBEP=true;
extern bool       JumpAfterBreakevenOnly=false;
extern bool       PartCloseEnabled=false;
extern double     Close_Lots = 0.02;
extern double     Preserve_Lots=0.02;
extern string     TSL="Trailing stop loss settings";
extern bool       TrailingStop=false;
extern int        TrailingStopPips=5;
extern bool       StopTrailAtPipsProfit=false;
extern int        StopTrailPips=0;
extern string     ITSL="Instant trailing stop loss settings";
extern bool       InstantTrailingStop=false;
extern int        InstantTrailingStopPips=30;
extern bool       StopInstantTrailAfterBreakEven=false;
extern bool       StopInstantTrailAtPipsProfit=false;
extern int        StopInstantTrailPips=0;
extern string     ITDCGC="Global DC trade closure";
extern bool       DcGlobalOrderClosureEnabled=true;
extern bool       DcProfitInDollars=false;
extern double     DcDollarProfit=100000;
extern bool       DcProfitAsPercentageOfBalance=true;
extern double     DcPercentageProfit=10;
extern string     bl3="---------------------------------------------------------------------";
extern string     ins23="-----Opposite direction trades-----";
extern bool       TakeOppositeDirectionTrades=false;
extern bool       TodtImmediate=true;
extern int        TodtTP=10;
extern int        TodtSL=10;
extern string     b20="---------------------------------------------------------------------";
extern string     ins8="-----General inputs-----";
extern int        MaxTradesAllowed=24;
extern double     Lot=0.01;
extern bool       TradeWeak=true;
extern bool       TradeStrong=true;
extern bool       CriminalIsUS=true;
extern string     PairSuffix="m";
extern int        MaximumSpread=10;
extern int        DisplayGapSize=30;
extern bool       ShowMagicNumbersOnScreen=false;
extern string     CurrencySymbol="$";
extern string     ins31="-----Trading time filters-----";
extern int        SleepMinsAtStartup=2;
extern bool       TradeSundayCandle=false;
extern int        MondayStartHour=3;
extern bool       StopTradingOnFriday=true;
extern int        FridayStopHour=14;
/*extern bool       UseAsiaTimeFilter=true;
extern int        AsiaStartTime=22;
extern int        AsiaEndTime=8;
extern bool       UseLondonTimeFilter=true;
extern int        LondonStartTime=8;
extern int        LondonEndTime=16;
extern bool       UseNewYorkTimeFilter=true;
extern int        NewYorkStartTime=13;
extern int        NewYorkEndTime=21;
*/
extern string     bl4="---------------------------------------------------------------------";
extern string     ins22="-----Management inputs-----";
extern string     sps="----Shirt-protection settings----";
extern string     spsi="Close all open trades at this $ loss";
extern bool       ShirtProtectionEnabled=false;
extern double     MaxLoss=-10000000;
extern bool       IncludePendingInClosure=false;
extern string     bl5="---------------------------------------------------------------------";
extern string     GOC="----Global order closure settings----";
extern bool       GlobalOrderClosureEnabled=false;
extern double     DollarProfit=100000;
extern string     bl6="---------------------------------------------------------------------";
extern string     NTP="----Pairs exclude list----";
extern string     NTP1="Enter the individual pairs (not Triggers)";
extern string     NTP2="you do not wish to trade";
extern string     NoTrade1;
extern string     NoTrade2;
extern string     NoTrade3;
extern string     NoTrade4;
extern string     NoTrade5;
extern string     bl7="---------------------------------------------------------------------";
extern bool       ShowAlerts=true;


// Misc variables
string            ScreenMessage; //Display user feedback
string            Gap;
bool              TradingAllowed=true;// In case user has both trading methods selected
bool              IsAsianSession=false;
bool              IsLondonSession=false;
bool              IsNewYorkSession=false;
double            bid, ask; // For storing the Bid\Ask so that one instance of the ea can manage all trades, if required
double            point, digits; // Saves the Point and Digits of an order
bool              GlobalVariablesExist=false;
string            TicketName = "GlobalVariableTicketNo";// For storing ticket numbers in global vars for picking up failed part-closes
int               ReturnedTicketNo;//For closing trades on a recross
bool              CloseAllDcTrades;// Force closure of all DC trades if there is a failure to close any
int               DcTradesOpen;
double            DcProfit;
bool              EaUseAllowed=true;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

   if (Period() != PERIOD_D1)
   {
      int answer = MessageBox("Warning: you not putting the DC EA onto a Daily chart. Do you wish to continue?", "Warning", MB_YESNO);
      if (answer != IDYES) 
      {   
         EaUseAllowed=false;
         Comment("Not being used. Please remove me as I get bored quickly.");
         return;
      }   
   }//if (Period != PERIOD_D1)
   
   //Take care of stops smaller than those allowed by the broker
   int BrokerStopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (DcTakeProfit > 0 && DcTakeProfit < BrokerStopLevel) DcTakeProfit = BrokerStopLevel;
   if (DcStopLoss > 0 && DcStopLoss < BrokerStopLevel) DcStopLoss = BrokerStopLevel;
   
   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }

   if (PairSuffix == " ") PairSuffix = "";//Deal with the dummies

   DcTradesTotal();
   
   //CheckTradingTimes();
   
   if (Digits == 3 || Digits == 5) MinStopLoss*=10;
   
   DisplayUserFeedback();
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sleeping for ",SleepMinsAtStartup, " minutes to give the indi time to initialise", NL);
   Comment(ScreenMessage);
   Sleep((SleepMinsAtStartup*60)*1000);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

void DisplayUserFeedback()
{
   

   string GvName;//Global variable name
   
   ScreenMessage=StringConcatenate("This Auto-Trader is the copyright of Steve Hopwood. It is available freely at www.forexfactory.com",NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Trading KG Daily Cross ");
   if (TradeKgMethod) ScreenMessage=StringConcatenate(ScreenMessage, " - KG instant trade method", NL);
   if (TradeSaharsMethod) 
   {
      ScreenMessage=StringConcatenate(ScreenMessage, " - Sahars pending trade method", NL);
      ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     SaharsPendingDistancePips = ", SaharsPendingDistancePips, ": SaharsPendingTimeLimitHours = ", SaharsPendingTimeLimitHours,NL);
   }
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Trades open = ", DcTradesOpen, ":  Total profit = ",CurrencySymbol, DoubleToStr(DcProfit,2),NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Maximum trades allowed = ",MaxTradesAllowed);
   ScreenMessage=StringConcatenate(ScreenMessage, ":  Lot size = ", Lot);
   ScreenMessage=StringConcatenate(ScreenMessage, ":  Maximum spread allowed = ", MaximumSpread,NL);   
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Trigger currencies enabled:",NL);
   if (TradeGBP) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     GBP",NL);
   if (TradeJPY) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     JPY",NL);
   if (TradeUSD) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     USD",NL);
   if (TradeEUR) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     EUR",NL);
   if (TradeCHF) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     CHF",NL);
   if (TradeAUD) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     AUD",NL);
   if (TradeNZD) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     NZD",NL);
   if (TradeCAD) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     CAD",NL);
   if (TakeOppositeDirectionTrades)
   {
      ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Taking opposite direction trades ");
      if (TodtImmediate) ScreenMessage=StringConcatenate(ScreenMessage, "immediately a trade is validated: ");
      ScreenMessage=StringConcatenate(ScreenMessage, "Take profit = ",TodtTP, ":  Stop loss = ",TodtSL,NL);
   }//if (TakeOppositeDirectionTrades)
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Magic number = ",DcMagicNumber,NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Trade comment = ",DailyCrossTradeComment,NL);
   if (OverrideMaxTradesAllowed) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Ignoring the maximum trades setting",NL);
   if (AutoDcCalcStopLoss) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Automatically calculating the stop loss. Minimum sl = ",MinStopLoss," pips",NL);
   else  ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Stop loss is ",DcStopLoss," pips",NL);
   if (CloseDcTradesOnRecross) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "CloseDcTradesOnRecross is enabled, at ", CloseDcTradesOnRecrossPoints, " points of recross (", CloseDcLowerTimeFrameFilter1,": ",CloseDcLowerTimeFrameFilter2,")", NL);
   else ScreenMessage=StringConcatenate(ScreenMessage, Gap, "CloseDcTradesOnRecross is disabled", NL);
   if (AutoCalculateTakeProfit) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Automatically calculating the take profit",NL);
   else  ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Take profit is ",DcTakeProfit," pips",NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot);
   ScreenMessage=StringConcatenate(ScreenMessage, ":   Maximum spread allowed = ", MaximumSpread,NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Minimum trading gap between triggers = ", MinGapBetweenTriggers,NL);
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "No_Trade_For_X_Bars = ", No_Trade_For_X_Bars, NL);
   if (ShirtProtectionEnabled) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Shirt protection enabled at ",CurrencySymbol, MaxLoss,NL);
   if (UseStochasticFilter)
   {
      ScreenMessage=StringConcatenate(ScreenMessage, Gap, "UseStochasticFilter is enabled at ", StochOverBought, "/", StochOverSold,NL);
   }
   else ScreenMessage=StringConcatenate(ScreenMessage, Gap, "UseStochasticFilter is not enabled",NL);
   
   if (UseMACD)
   {
      ScreenMessage=StringConcatenate(ScreenMessage, Gap, "UseMACD is enabled. Period = ", MacdPeriod, ": MacdLookBackBars = ", MacdLookBackBars,NL);
   }
   else ScreenMessage=StringConcatenate(ScreenMessage, Gap, "UseMACD is not enabled",NL);

   if (UseShamusFamous) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "ShamusFamous is enabled",NL);

   if (ImmediateEntryOnCross) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Using instant entry on cross settings",NL);
   else ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Using standard KG entry settings",NL);
   if (ImmediateAlertOnCross) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Showing an Alert on first cross",NL);
   if (EaManagesTrades)
   {
      ScreenMessage=StringConcatenate(ScreenMessage, Gap, "EA trade management settings:",NL);
         if (DcGlobalOrderClosureEnabled)
         {
            ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     Global closure of DC trades is enabled.  ");
            if (DcProfitInDollars) ScreenMessage=StringConcatenate(ScreenMessage, "Profit target is ", CurrencySymbol, DcDollarProfit,NL);
            if (DcProfitAsPercentageOfBalance) ScreenMessage=StringConcatenate(ScreenMessage, "Profit target is ",DcPercentageProfit,"%", NL);
         }//if (DcGlobalOrderClosureEnabled)
         else ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     Global closure of DC trades is disabled",NL);
   

      if (BreakEven) ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     Break even set to ",BreakEvenPips, " to lock in ", BreakEvenProfit, " pips",NL);
      if (JumpingStop) 
      {
         ScreenMessage=StringConcatenate(ScreenMessage, Gap, "     Jumping stop set to ", JumpingStopPips, " pips: ");
         if (AddBEP) ScreenMessage=StringConcatenate(ScreenMessage, "AddBEP is set to ",BreakEvenProfit, " pips");
         if (JumpAfterBreakevenOnly) ScreenMessage=StringConcatenate(ScreenMessage, ": Jump will start after breakeven only");
         ScreenMessage=StringConcatenate(ScreenMessage,NL);
         if (PartCloseEnabled)
         {
            ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Trade part-close is enabled. Closing ",Close_Lots, ": Preserving ", Preserve_Lots,NL);
         }
      }//if (JumpingStop)
      
      if(TrailingStop==true)
      {
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, "     Trailing stop on and set to ", TrailingStopPips,NL);
      }//if(TrailingStop==true)

      if (InstantTrailingStop)
         {
            ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Instant trailing stop on and set to ", InstantTrailingStopPips);
            if (StopInstantTrailAfterBreakEven) ScreenMessage = StringConcatenate(ScreenMessage,
                  ": Will disable after breakeven");
            ScreenMessage=StringConcatenate(ScreenMessage,NL);      
         }//if (InstantTrailingStop)
  
   }//if (EaManagesTrades)
   ScreenMessage=StringConcatenate(ScreenMessage, Gap, "Validating these crosses (lower TF ",LowerTimeFrameFilter1, "; ", LowerTimeFrameFilter2, "; ", LowerTimeFrameFilter3, "; ", LowerTimeFrameFilter4, "):",NL);
   SetUpCrossesDisplay();
      // Sunday candle
   if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal())==0) 
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended - Sunday candle. Continuing to manage open trades.",NL);         
   }//if (!TradeSundayCandle && TimeDayOfWeek(TimeCurrent())==0) 
   
   //Monday start
   if (TimeDayOfWeek(TimeLocal())==1 && TimeHour(TimeLocal()) < MondayStartHour)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended - too early on Monday. Continuing to manage open trades.",NL);         
   }//if (!TradeSundayCandle && TimeDayOfWeek(TimeCurrent())==0) 
   
   //Friday shut down
   if (StopTradingOnFriday)
   {
      if (TimeDayOfWeek(TimeLocal())==5)
      {   
         if (TimeHour(TimeLocal()) >= FridayStopHour)
         {
            ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Friday close. Continuing to manage open trades.",NL);
         }//if (TimeHour(TimeCurrent()) >= FridayStopHour)   
      }//if TimeDayOfWeek(TimeCurrent()==5)   
   }//if (StopTradingOnFriday)


   Comment(ScreenMessage);
   return;
}// End void DisplayUserFeedback()

void CheckPendingTradeEntryLevel()
{
   // Adjusts the fill price of a pending trade when the market has moved sufficiently.
   // Called by the Start function. The trade is already selected by OrderSelect
   
   int TicketNo = OrderTicket();         
   string symbol = OrderSymbol();
   double DistanceAway = NormalizeDouble((SaharsPendingDistancePips * 2) * point, digits);
   // OP_BUYSTOP
   if (OrderType() == 4) 
   {
      if (OrderOpenPrice() - MarketInfo(symbol, MODE_ASK) >= DistanceAway)
      {
         int ticket = OrderDeleteReliable(TicketNo);
         if (ticket < 0)
         {
            int err=GetLastError();
            if (ShowAlerts) Alert("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));
            Print("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));               
         }//if (ticket < 0)
         TakeLongDcTrade(symbol, 4);
      }//if (OrderOpenPrice() - ask >= DistanceAway)
      return;
   }//if (OrderType == 4)
   
   // OP_SELLSTOP
   if (OrderType() == 5) 
   {
      if (MarketInfo(symbol, MODE_BID) - OrderOpenPrice() >= DistanceAway)
      {
         OrderDeleteReliable(TicketNo);
         if (ticket < 0)
         {
            err=GetLastError();
            if (ShowAlerts) Alert("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));
            Print("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));               
         }//if (ticket < 0)
         TakeShortDcTrade(symbol, 5);
      }//if (OrderOpenPrice() - ask >= DistanceAway)
      return;
   }//if (OrderType == 5)
   
}//void CheckPendingTradeEntryLevel()

bool HaveBarsPassed(string symbol)
{
   // Called from the CompareTriggerStrengths function.
   // Cycles through the history to see how long ago each relevant trad closed.
   // Returns true if enough time has passed, else false 
   
   int histotal = OrdersHistoryTotal();
   if (histotal > 0 && No_Trade_For_X_Bars > 0)
   {
      for(int cnt=0;cnt<histotal;cnt++)
      {
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
         {
            if(OrderMagicNumber() == DcMagicNumber && OrderSymbol() == symbol)
            {
               for (int b=0;b < No_Trade_For_X_Bars;b++)
               {
                  if (Time[b] <= OrderCloseTime()) return(false);// if b=0, don't open a new position if we're still on the same candle
               }//for (int b=0;b < No_Trade_For_X_Bars;b++)   
            }//if(OrderMagicNumber() == DcMagicNumber && OrderSymbol() == symbol)            
         }//if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
      }//for(int cnt=0;cnt<histotal;cnt++)      
   }//if (histotal > 0)
   return(true);// Got this far, so the condition is ok
}// End bool HaveBarsPassed(string symbol)

bool ReadMACD(int type, string symbol)
{
   // Returns the value of MACD, using indi defaults
   
   
   double MacdVal[];   
   double array1  = ArrayResize(MacdVal, MacdLookBackBars);
   
   for (int cc = 0; cc < MacdLookBackBars; cc++)
   {
      MacdVal [cc] = iMACD(symbol, MacdPeriod, 13, 21, 8, PRICE_CLOSE, MODE_MAIN, cc);
      // Long filter
      if (type == 0 && MacdVal [cc] < 0) return(false);
      // Short filter
      if (type == 1 && MacdVal [cc] > 0) return(false);
   }//for (int cc = 0; cc < MacdLookBackBars; cc++)
   
   // Got this far, so MACD must be going in the right direction
   return(true);
   
}// End bool ReadMACD(int type, string symbol)   

bool ShamusFamousFilter(int type, string symbol)
{
   /*
   When I get a long signal for example, I check the D1 candle for trend. 
   Simply said If the d1 candle is higher than open of candle (up) I'll take that trade. Reverse for shorts.
   I check this every time I get a valid signal.
   */
   
   // Retruns true if trend confirms the trade, else false
   
   // Check long trade.
   // D1 must be higher than at open
   if (type == 0)
   {
      if (Ask > iOpen(symbol,0,0)) return(true);
      else return(false);   
   }//if (type == 0)
 
   // D1 must be lower than at open
   if (type == 1)
   {
      if (Bid < iOpen(symbol,0,0)) return(true);
      else return(false);   
   }//if (type == 0)
 
   
}//bool ShamusFamousFilter(int type, string symbol)


bool CheckRecrossOnLowerTf(string T1, string T2, int TimeFrame, int type)
{
   // After a recross on the main trigger strength, checks the lower tf's for a recross.
   // type is the OrderType of the trade being investigated, so we are looking for a recross in the opposite direction.
   // Returns true if a recross occurs, else returns false

   // Set up trigger index for reading and storing trigger strengths
   int TriggerIndex1, TriggerIndex2;
   double TriggerCurrencyA2, TriggerCurrencyA1, TriggerCurrencyA0; // 2=2 days ago; 1=1 day ago; 0 = today
   double TriggerCurrencyB2, TriggerCurrencyB1, TriggerCurrencyB0;
  
   if (T1 == "JPY") TriggerIndex1 = 1;
   if (T1 == "USD") TriggerIndex1 = 0;
   if (T1 == "GBP") TriggerIndex1 = 4;
   if (T1 == "EUR") TriggerIndex1 = 6;
   if (T1 == "CHF") TriggerIndex1 = 2;
   if (T1 == "AUD") TriggerIndex1 = 5;
   if (T1 == "NZD") TriggerIndex1 = 7;
   if (T1 == "CAD") TriggerIndex1 = 3;
   
   if (T2 == "JPY") TriggerIndex2 = 1;
   if (T2 == "USD") TriggerIndex2 = 0;
   if (T2 == "GBP") TriggerIndex2 = 4;
   if (T2 == "EUR") TriggerIndex2 = 6;
   if (T2 == "CHF") TriggerIndex2 = 2;
   if (T2 == "AUD") TriggerIndex2 = 5;
   if (T2 == "NZD") TriggerIndex2 = 7;
   if (T2 == "CAD") TriggerIndex2 = 3;
  
   TriggerCurrencyA1 = iCustom(NULL,TimeFrame, "KG RS GROUP V1.1",TriggerIndex1,1);// previous
   TriggerCurrencyA0 = iCustom(NULL,TimeFrame, "KG RS GROUP V1.1",TriggerIndex1,0);// noe
   
   TriggerCurrencyB1 = iCustom(NULL,TimeFrame, "KG RS GROUP V1.1",TriggerIndex2,1);// previous
   TriggerCurrencyB0 = iCustom(NULL,TimeFrame, "KG RS GROUP V1.1",TriggerIndex2,0);// now

   // Check long trade, so return true if recross on the short side has occurred
   if (type == 0)
   {
      if (TriggerCurrencyA1 > TriggerCurrencyB1 && TriggerCurrencyA0 < TriggerCurrencyB0) return(true);
      else return(false);
   }//if (type == 0)

   // Check short trade, so return true if recross on the long side has occurred
   if (type == 1)
   {
      if (TriggerCurrencyA1 < TriggerCurrencyB1 && TriggerCurrencyA0 > TriggerCurrencyB0) return(true);
      else return(false);
   }//if (type == 0)

}// bool CheckRecrossOnLowerTf(string T1, string T2, int TimeFrame, int type)

bool IsThisPairExcluded(string symbol)
{
   //Returns true if the pair should be excluded from trading, false if not.
   
   if (symbol == NoTrade1 || symbol == NoTrade2 || symbol == NoTrade3 || symbol == NoTrade4 || symbol == NoTrade5)
   {
      return(true);
   }
   
   // Got this far, so pair is tradable
   return(false);
   
}// End bool IsThisPairExcluded(string symbol)


void CompareTriggerStrengths(string T1, string T2)
{
   // Checks for crosses and sets up globals to tell the EA to send trades if lower tf's match up.
   // T1 == trigger 1 eg GBP out of a GBP/JPY comparison.
   // T2 == trigger 2 eg JPY out of a GBP/JPY comparison.
   
   // Does a trade already exists? Use the result later in this function
   string symbol = StringConcatenate(T1,T2,PairSuffix);
   bool TradeExists = DoesTradeExist(symbol);
   

   // Check the pair is traded by the broker. Use matrixrbiz's suggestion of checking the spread
   if (MarketInfo(symbol, MODE_SPREAD) < 1) return;
   
   // Abort routine if individual trigger is disabled
   if (T1 == "JPY" && !TradeJPY) return;
   if (T1 == "USD" && !TradeUSD) return;
   if (T1 == "GBP" && !TradeGBP) return;
   if (T1 == "EUR" && !TradeEUR) return;
   if (T1 == "CHF" && !TradeCHF) return;
   if (T1 == "AUD" && !TradeAUD) return;
   if (T1 == "NZD" && !TradeNZD) return;
   if (T1 == "CAD" && !TradeCAD) return;

   if (T2 == "JPY" && !TradeJPY) return;
   if (T2 == "USD" && !TradeUSD) return;
   if (T2 == "GBP" && !TradeGBP) return;
   if (T2 == "EUR" && !TradeEUR) return;
   if (T2 == "CHF" && !TradeCHF) return;
   if (T2 == "AUD" && !TradeAUD) return;
   if (T2 == "NZD" && !TradeNZD) return;
   if (T2 == "CAD" && !TradeCAD) return;
   
   // Abort funtion if a trade has been closed and No_Trade_For_X_Bars period has not passed.
   bool TimeHasPassed = HaveBarsPassed(symbol);
   if (!TimeHasPassed) return;
   

   // Set up trigger index for reading and storing trigger strengths
   int TriggerIndex1, TriggerIndex2;
   double TriggerCurrencyA2, TriggerCurrencyA1, TriggerCurrencyA0; // 2=2 days ago; 1=1 day ago; 0 = today
   double TriggerCurrencyB2, TriggerCurrencyB1, TriggerCurrencyB0;
  
   if (T1 == "JPY") TriggerIndex1 = 1;
   if (T1 == "USD") TriggerIndex1 = 0;
   if (T1 == "GBP") TriggerIndex1 = 4;
   if (T1 == "EUR") TriggerIndex1 = 6;
   if (T1 == "CHF") TriggerIndex1 = 2;
   if (T1 == "AUD") TriggerIndex1 = 5;
   if (T1 == "NZD") TriggerIndex1 = 7;
   if (T1 == "CAD") TriggerIndex1 = 3;
   
   if (T2 == "JPY") TriggerIndex2 = 1;
   if (T2 == "USD") TriggerIndex2 = 0;
   if (T2 == "GBP") TriggerIndex2 = 4;
   if (T2 == "EUR") TriggerIndex2 = 6;
   if (T2 == "CHF") TriggerIndex2 = 2;
   if (T2 == "AUD") TriggerIndex2 = 5;
   if (T2 == "NZD") TriggerIndex2 = 7;
   if (T2 == "CAD") TriggerIndex2 = 3;
  
   TriggerCurrencyA2 = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex1,2);// 2 days ago
   TriggerCurrencyA1 = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex1,1);// yesterday
   TriggerCurrencyA0 = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex1,0);// today
   
   TriggerCurrencyB2 = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex2,2);// 2 days ago
   TriggerCurrencyB1 = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex2,1);// yesterday
   TriggerCurrencyB0 = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex2,0);// today


   // If a trade already exists, close it if the trigger indices have re-crossed.
   // DoesTradeExist() leaves the exiting trade selected
   if (TradeExists && CloseDcTradesOnRecross) 
   {      
      bool CloseTrade = true;
      OrderSelect(ReturnedTicketNo, SELECT_BY_TICKET);
      // Buy trade
      if (OrderType() == OP_BUY)
      {
         if (TriggerCurrencyA0 < TriggerCurrencyB0 && TriggerCurrencyB0 - TriggerCurrencyA0 >= CloseDcTradesOnRecross) 
         {
            if (CloseDcLowerTimeFrameFilter1 > 0) CloseTrade = CheckRecrossOnLowerTf(T1, T2, CloseDcLowerTimeFrameFilter1, OrderType());
            if (CloseTrade) CloseTrade = CheckRecrossOnLowerTf(T1, T2, CloseDcLowerTimeFrameFilter2, OrderType());
            if (CloseTrade)
            {
               bool result = OrderCloseReliableMKT(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 10, CLR_NONE);
               if (!result)
               {
                  int err=GetLastError();
                  if (ShowAlerts) Alert("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));
                  Print("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));               
               }//if (ticket < 0)
               else if (ShowAlerts) Alert("Order no ", OrderTicket(), " closed because of recross");
            }//if (CloseTrade)
         }//if (TriggerCurrencyA0 < TriggerCurrencyB0)    
      }//if (OrderType() == OP_BUY)   
   
      if (OrderType() == OP_SELL)
      {
         if (TriggerCurrencyA0 > TriggerCurrencyB0 && TriggerCurrencyA0 - TriggerCurrencyB0 >= CloseDcTradesOnRecross) 
         {
            if (CloseDcLowerTimeFrameFilter1 > 0) CloseTrade = CheckRecrossOnLowerTf(T1, T2, CloseDcLowerTimeFrameFilter1, OrderType());
            if (CloseTrade) CloseTrade = CheckRecrossOnLowerTf(T1, T2, CloseDcLowerTimeFrameFilter2, OrderType());
            if (CloseTrade)
            {                       
               result = OrderCloseReliableMKT(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 10, CLR_NONE);
               if (!result)
               {
                  err=GetLastError();
                  if (ShowAlerts) Alert("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));
                  Print("Order close failed for ticket no ", OrderTicket(), " with error(",err,"): ",ErrorDescription(err));
               }//if (ticket < 0)
               else if (ShowAlerts) Alert("Order no ", OrderTicket(), " closed because of recross");
            }//if (CloseTrade)
         }//if (TriggerCurrencyA0 > TriggerCurrencyB0)    
      }//if (OrderType() == OP_BUY)   
   }//if (TradeExists) 
   
   //Nothing to do. Even if a trade has been closed by a recross, the new cross will be picked up at the next tick
   if (TradeExists) return;
   
   // Check that this pair is not on the exclude list
   bool PairExcluded = IsThisPairExcluded(symbol);
   if (PairExcluded) return;
   
   // Global variable trade storage name
   string GvTradeName = StringConcatenate("KgDc", T1,T2, "PendingTrade");
   
   // Actually check for a cross and set the gv with one of these values:
   // Long trade = 0
   // Short trade = 1
  
   bool SendTrade = true;// Use in filter calls. It is set to 'false' by ReadMACD if trend is in wrong direction for the trade
   
   if (!ImmediateEntryOnCross)// KG method
   {
      // Check for long trade cross KG method.
      if (TriggerCurrencyA2 < TriggerCurrencyB2 && TriggerCurrencyA1 > TriggerCurrencyB1 && TriggerCurrencyA0 > TriggerCurrencyB0)
      {
         // Check that both triggers are moving in contrary motion, not similar motion.
         if ((TriggerCurrencyA2 < TriggerCurrencyA1 && TriggerCurrencyA1 < TriggerCurrencyA0) && (TriggerCurrencyB2 > TriggerCurrencyB1 && TriggerCurrencyB1 > TriggerCurrencyB0)) 
         {   
            if (UseMACD) SendTrade = ReadMACD(OP_BUY, symbol);
            if (!SendTrade) return;
            if (UseShamusFamous) SendTrade = ShamusFamousFilter(OP_BUY, symbol);
            if (!SendTrade) return;
            if (SendTrade) GlobalVariableSet(GvTradeName, 0);
         }//if ((TriggerCurrencyA2 < TriggerCurrencyA1 && TriggerCurrencyA1 < TriggerCurrencyA0) && (TriggerCurrencyB2 > TriggerCurrencyB1 && TriggerCurrencyB1 > TriggerCurrencyB0))    
      }//if (TriggerCurrencyA2 < TriggerCurrencyB2 && TriggerCurrencyA1 > TriggerCurrencyB1 && TriggerCurrencyA0 > TriggerCurrencyB0)
   
      // Check for short trade cross.
      if (TriggerCurrencyA2 > TriggerCurrencyB2 && TriggerCurrencyA1 < TriggerCurrencyB1 && TriggerCurrencyA0 < TriggerCurrencyB0)
      {
         // Check that both triggers are moving in contrary motion, not similar motion.
         if ((TriggerCurrencyA2 > TriggerCurrencyA1 && TriggerCurrencyA1 > TriggerCurrencyA0) && (TriggerCurrencyB2 < TriggerCurrencyB1 && TriggerCurrencyB1 < TriggerCurrencyB0)) 
         {   
            if (UseMACD) SendTrade = ReadMACD(OP_SELL, symbol);
            if (!SendTrade) return;
            if (UseShamusFamous) SendTrade = ShamusFamousFilter(OP_SELL, symbol);
            if (!SendTrade) return;
            if (SendTrade) GlobalVariableSet(GvTradeName, 1);
         }//if ((TriggerCurrencyA2 > TriggerCurrencyA1 && TriggerCurrencyA1 > TriggerCurrencyA0) && (TriggerCurrencyB2 < TriggerCurrencyB1 && TriggerCurrencyB1 < TriggerCurrencyB0))    
      }//if (TriggerCurrencyA2 > TriggerCurrencyB2 && TriggerCurrencyA1 < TriggerCurrencyB1 && TriggerCurrencyA0 < TriggerCurrencyB0)
   }//if (!ImmediateAlertOnCross)
   
   if (ImmediateEntryOnCross)// Immediate method
   {
      // Check for long trade cross KG method.
      if (TriggerCurrencyA1 < TriggerCurrencyB1 && TriggerCurrencyA0 > TriggerCurrencyB0)
      {
         // Check that both triggers are moving in contrary motion, not similar motion.
         if ((TriggerCurrencyA1 < TriggerCurrencyA0) && (TriggerCurrencyB1 > TriggerCurrencyB0)) GlobalVariableSet(GvTradeName, 0);
      }//if (TriggerCurrencyA2 < TriggerCurrencyB2 && TriggerCurrencyA1 > TriggerCurrencyB1 && TriggerCurrencyA0 > TriggerCurrencyB0)
   
      // Check for short trade cross.
      if (TriggerCurrencyA1 > TriggerCurrencyB1 && TriggerCurrencyA0 < TriggerCurrencyB0)
      {
         if ((TriggerCurrencyA1 > TriggerCurrencyA0) && (TriggerCurrencyB1 < TriggerCurrencyB0)) GlobalVariableSet(GvTradeName, 1);
      }//if (TriggerCurrencyA2 > TriggerCurrencyB2 && TriggerCurrencyA1 < TriggerCurrencyB1 && TriggerCurrencyA0 < TriggerCurrencyB0)
   }//if (!ImmediateAlertOnCross)
   
   // Check for mrpipster's immediate cross and sound an Alert
   if (ImmediateAlertOnCross)
   {
      GvTradeName = StringConcatenate("KgDc", T1,T2, "FirstCross");
      int GvVal=-1;
      if (GlobalVariableCheck(GvTradeName)) GvVal = GlobalVariableGet(GvTradeName);
      // Long cross
      if (TriggerCurrencyA1 < TriggerCurrencyB1 && TriggerCurrencyA0 > TriggerCurrencyB0)
      {         
         if (GvVal == -1 || GvVal == 1)
         {
            Alert("Long cross by ", T1, " over ",T2);
            GlobalVariableSet(GvTradeName,0);
         }//if (GvVal == -1 || GvVal == 1)
      }//if (TriggerCurrencyA1 < TriggerCurrencyB1 && TriggerCurrencyA0 > TriggerCurrencyB0)
      
      // Short cross
      if (TriggerCurrencyA1 > TriggerCurrencyB1 && TriggerCurrencyA0 < TriggerCurrencyB0)
      {
         if (GvVal == -1 || GvVal == 0)
         {
            Alert("Short cross by ", T1, " under ",T2);
            GlobalVariableSet(GvTradeName,1);
         }//if (GvVal == -1 || GvVal == 0)
      }//if (TriggerCurrencyA1 > TriggerCurrencyB1 && TriggerCurrencyA0 < TriggerCurrencyB0)         
   }//if (ImmediateAlertOnCross)
   
}// End void CompareTriggerStrengths(string T1, string T2, double T1Val, double T2Val)

void CheckForCrosses()
{
   // Sets up the paramaters to send to CompareTriggerStrength, which checks for crosses and 
   // sets up globals to tell the EA to send trades at the next opportunity
   
  
   // GBP pairs
   if (TradeGBP)
   {
      if (TradeJPY) CompareTriggerStrengths("GBP", "JPY");
      if (TradeUSD) CompareTriggerStrengths("GBP", "USD");
      if (TradeEUR) CompareTriggerStrengths("EUR", "GBP");
      if (TradeCHF) CompareTriggerStrengths("GBP", "CHF");
      if (TradeAUD) CompareTriggerStrengths("GBP", "AUD");
      if (TradeNZD) CompareTriggerStrengths("GBP", "NZD");
      if (TradeCAD) CompareTriggerStrengths("GBP", "CAD");            
   }//if (TradeGBP)


   // JPY pairs
   if (TradeJPY)
   {
      if (TradeEUR) CompareTriggerStrengths("EUR", "JPY");
      if (TradeUSD) CompareTriggerStrengths("USD", "JPY");
      if (TradeCHF) CompareTriggerStrengths("CHF", "JPY");
      if (TradeAUD) CompareTriggerStrengths("AUD", "JPY");
      if (TradeNZD) CompareTriggerStrengths("NZD", "JPY");
      if (TradeCAD) CompareTriggerStrengths("CAD", "JPY");   
   }//if (TradeJPY)
   
   // USD pairs
   if (TradeUSD)
   {
      if (TradeEUR) CompareTriggerStrengths("EUR", "USD");
      if (TradeCAD) CompareTriggerStrengths("USD", "CAD");
      if (TradeNZD) CompareTriggerStrengths("NZD", "USD");
      if (TradeAUD) CompareTriggerStrengths("AUD", "USD");
      if (TradeCHF) CompareTriggerStrengths("USD", "CHF");
   }//if (TradeUSD)

   
   // EUR pairs
   if (TradeEUR)
   {
      if (TradeCHF) CompareTriggerStrengths("EUR", "CHF");
      if (TradeCAD) CompareTriggerStrengths("EUR", "CAD");
      if (TradeNZD) CompareTriggerStrengths("EUR", "NZD");
      if (TradeAUD) CompareTriggerStrengths("EUR", "AUD");
   }//if (TradeEUR)

   // AUD pairs
   if (TradeAUD)
   {
      if (TradeCHF) CompareTriggerStrengths("AUD", "CHF");
      if (TradeNZD) CompareTriggerStrengths("AUD", "NZD");
      if (TradeCAD) CompareTriggerStrengths("AUD", "CAD");      
   }//if (TradeAud)

   // CHF pairs
   if (TradeCHF)
   {
      if (TradeNZD) CompareTriggerStrengths("NZD", "CHF");
      if (TradeCAD) CompareTriggerStrengths("CAD", "CHF");            
   }//if (TradeCHF)
   
   
   
}// End void CheckForCrosses()

bool DoesTradeExist(string symbol)
{
   // Returns true if a trade already exists, false if not
   
   if (OrdersTotal() == 0) return(false); // NOthing to do
   
   for (int cc = 0; cc < OrdersTotal(); cc++)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      ReturnedTicketNo=(OrderTicket());
      if (OrderSymbol() == symbol && OrderMagicNumber() == DcMagicNumber) return(true);
      //Check that trade would be allowed by US criminals
      if (CriminalIsUS)
      {
         if (OrderSymbol() == symbol) return(true);
      }//if (CriminalIsUS)
   
   }//for (int cc = 0; cc < OrdersTotal(); cc++)

   // Got this far, so trade does not exist
   return(false);
}// End bool DoesTradeExist(string symbol)

double ReadStochastic(string symbol)
{
   // Returns the value of Stoch indi
   double StochVal = iStochastic(symbol, 0, 8, 3, 3, 0, 1, MODE_MAIN, 0);
   return(StochVal);
   
}//double ReadStochastic(string symbol)

bool TakeLongDcTrade(string symbol, int type)
   {
      // Returns 'true' if the OrderSend succeeds, 'false' if not
/*OK.. once a cross has occured, i suggest we entering the trade on the next candle open with SL at High 
previous candle+spread+10 for SELL and Low previous candle+spread+10 for BUY (If we need a SL). 
This is for individual trade base on D1 chart.
*/

      
      
      double stoploss, takeprofit; // tp in case we decide to add one
      
      double spread, point, digits;
      spread = MarketInfo(symbol, MODE_SPREAD);
      point = MarketInfo(symbol, MODE_POINT);
      digits = MarketInfo(symbol, MODE_DIGITS);
      
      double price;
      if (type == OP_BUY) price = MarketInfo(symbol,MODE_ASK);
      if (type == OP_BUYSTOP) price = NormalizeDouble(MarketInfo(symbol,MODE_ASK) + (SaharsPendingDistancePips*point),digits);
      
      // User defined stop loss in pips
      if (DcStopLoss > 0)
      {
         stoploss = NormalizeDouble(price - (DcStopLoss * point) - (spread * point), digits);
      }//if (DcStopLoss > 0)
      
      // SL based on previous candle
      if (AutoDcCalcStopLoss)
      {
         int DistanceFromPrice;
         if (digits == 2 || digits == 4) DistanceFromPrice = 10;
         if (digits == 3 || digits == 5) DistanceFromPrice = 100;
         stoploss = NormalizeDouble(iLow(symbol,0,1) - (spread * point) - (DistanceFromPrice * point),digits);
         // Check the sl is far enough away
         double val = MarketInfo(symbol,MODE_BID) - stoploss;
         int multiplier;
         if (digits==2) multiplier = 100;
         if (digits==3) multiplier = 1000;
         if (digits==4) multiplier = 10000;
         if (digits==5) multiplier = 100000;
         val = val * multiplier;
         if (val < 200)
         {
            if (digits == 2 || digits == 4) DistanceFromPrice = 200;
            if (digits == 3 || digits == 5) DistanceFromPrice = 2000;         
            stoploss = NormalizeDouble(MarketInfo(symbol,MODE_BID) - (DistanceFromPrice * point),digits);
         }//if (val < 200)
         
      }//if AutoDcCalcStopLoss)
      
      // User defined take profit
      if (DcTakeProfit > 0)
      {
         takeprofit=NormalizeDouble(price + (DcTakeProfit * point) + (spread * point), digits);
      }//if (DcStopLoss > 0)
      
      // TP based on ATR\ADX
      if (AutoCalculateTakeProfit)
      {
         // Calculate tp by getting ATR and using ADX to set the multiplier
         double AtrValue=iATR(symbol,0,AtrPeriod,0);
         if (iADX(symbol,0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) >20 && AdxPeriod >0) AtrValue=AtrValue*4;
         if (iADX(symbol,0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) <=20 && AdxPeriod >0) AtrValue=AtrValue*2;
      
         takeprofit=price+AtrValue;         
      }//if (AutoCalculateTakeProfit)

      datetime ExpirationTime;
      if (type == OP_BUYSTOP) ExpirationTime = TimeCurrent() + (SaharsPendingTimeLimitHours * 3600);
      //Broker is a normal crook
      if (!BrokerIs2stageCrook)
      {
         if (type == OP_BUY) int ticket=OrderSendReliableMKT(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);
         if (type == OP_BUYSTOP) ticket=OrderSendReliable(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);
      }//if (!BrokerIs2stageCrook)
      
      //Broker is a 2 stage crook
      if (BrokerIs2stageCrook)
      {
         if (type == OP_BUY) ticket=OrderSendReliable2Step(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);
         if (type == OP_BUYSTOP) ticket=OrderSendReliable2Step(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);
      }//if (BrokerIs2stageCrook)
      
      if (ticket > -1) 
      {
         // Opposite direction trade to scalp a few pips
         if (TakeOppositeDirectionTrades)
         {
            // Open the trade immediately
            if (TodtImmediate)
            {
               stoploss = 0;
               takeprofit=0;
               if (TodtSL > 0)
               {
                  stoploss = NormalizeDouble(MarketInfo(symbol, MODE_ASK)  + (TodtSL * point), digits);
               }//if (TodSl > 0)
               if (TodtTP > 0)
               {
                  takeprofit=NormalizeDouble(MarketInfo(symbol,MODE_ASK) - (TodtTP * point) - (spread * point), digits);
               }//if (DcTakeProfit > 0)
               if (!BrokerIs2stageCrook) ticket=OrderSendReliableMKT(symbol,OP_SELL,Lot,MarketInfo(symbol,MODE_BID),10,stoploss,takeprofit,DailyCrossTradeComment + " ODT", DcMagicNumber,ExpirationTime,CLR_NONE);      
               if (BrokerIs2stageCrook) ticket=OrderSendReliable2Step(symbol,OP_SELL,Lot,MarketInfo(symbol,MODE_BID),10,stoploss,takeprofit,DailyCrossTradeComment + " ODT", DcMagicNumber,ExpirationTime,CLR_NONE);      
               if (ticket < 0)
               {
                  int err=GetLastError();
                  Alert(symbol, " Opposite direction Sell order send failed with error(",err,"): ",ErrorDescription(err));
                  Print(symbol, " Opposite direction Sell order send failed with error(",err,"): ",ErrorDescription(err));
                  return(false);
               }//if (ticket < 0)
            }//if (TodtImmediate)
         }//if (TakeOppositeDirectionTrades)
         return(true);
      }//if (ticket > -1) 
      else 
      {
         err = GetLastError();
         if (err == 4106) return(true); //Unknown symbol error
         else 
         {
            Alert(symbol, " DC Buy order send failed with error(",err,"): ",ErrorDescription(err));
            Print(symbol, " DC Buy order send failed with error(",err,"): ",ErrorDescription(err));
            return(false);
         }//else
      }
   
   }// End TakeLongDcTrade()

bool TakeShortDcTrade(string symbol, int type)
   {
      // Returns 'true' if the OrderSend succeeds, 'false' if not
      
      // Check Stoch valuse first, and end routine if overbought
      if (UseStochasticFilter)
      {
         double StochVal = iStochastic(symbol, 0, 8, 3, 3, 0, 1, MODE_MAIN, 0);
         // If overbought, return true to make the EA think the trade was sent and delete the global
         if (StochVal <= StochOverSold) return(true);         
      }//if (UseStochasticFilter)

      
      double stoploss, takeprofit; // tp in case we decide to add one

      double spread, point, digits;
      spread = MarketInfo(symbol, MODE_SPREAD);
      point = MarketInfo(symbol, MODE_POINT);
      digits = MarketInfo(symbol, MODE_DIGITS);
      
      
      double price;
      if (type == OP_SELL) price = MarketInfo(symbol,MODE_BID);
      if (type == OP_SELLSTOP) price = NormalizeDouble(MarketInfo(symbol,MODE_BID) - (SaharsPendingDistancePips*point),digits);
      
      if (DcStopLoss > 0)
      {
         stoploss = NormalizeDouble(price + (DcStopLoss * point) + (spread * point), digits);         
      }
      
      
      // SL based on previous candle
      if (AutoDcCalcStopLoss)
      {
         int DistanceFromPrice;
         if (digits == 2 || digits == 4) DistanceFromPrice = 10;
         if (digits == 3 || digits == 5) DistanceFromPrice = 100;
         stoploss = NormalizeDouble(iHigh(symbol,0,1) + (spread * point) + (DistanceFromPrice * point),digits);
         // Check the sl is far enough away
         double val = stoploss - MarketInfo(symbol,MODE_ASK);
         int multiplier;
         if (digits==2) multiplier = 100;
         if (digits==3) multiplier = 1000;
         if (digits==4) multiplier = 10000;
         if (digits==5) multiplier = 100000;
         val = val * multiplier;
         if (val < 200)
         {
            if (digits == 2 || digits == 4) DistanceFromPrice = 200;
            if (digits == 3 || digits == 5) DistanceFromPrice = 2000;            
            stoploss = NormalizeDouble(price + (DistanceFromPrice * point),digits);
         }//if (val < 200)
         
      }//if AutoDcCalcStopLoss)
      
      
      // User defined take profit
      if (DcTakeProfit > 0)
      {
         takeprofit=NormalizeDouble(price - (DcTakeProfit * point) - (spread * point), digits);
      }//if (DcStopLoss > 0)
      
   
      // TP based on ATR\ADX
      if (AutoCalculateTakeProfit)
      {
         // Calculate tp by getting ATR and using ADX to set the multiplier
         double AtrValue=iATR(symbol,0,AtrPeriod,0);
         if (iADX(symbol,0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) >20 && AdxPeriod >0) AtrValue=AtrValue*4;
         if (iADX(symbol,0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,0) <=20 && AdxPeriod >0) AtrValue=AtrValue*2;
      
         takeprofit = price - AtrValue;
      }//if (AutoCalculateTakeProfit)

      datetime ExpirationTime;
      if (type == OP_SELLSTOP) ExpirationTime = TimeCurrent() + (SaharsPendingTimeLimitHours * 3600);

   
      //Broker is a normal crook
      if (!BrokerIs2stageCrook)
      {
         if (type == OP_SELL) int ticket=OrderSendReliableMKT(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);      
         if (type == OP_SELLSTOP) ticket=OrderSendReliable(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);      
      }//if (!BrokerIs2stageCrook)
      
      //Broker is a 2 stage crook
      if (BrokerIs2stageCrook)
      {
         if (type == OP_SELL) ticket=OrderSendReliable2Step(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);      
         if (type == OP_SELLSTOP) ticket=OrderSendReliable2Step(symbol,type,Lot,price,10,stoploss,takeprofit,DailyCrossTradeComment,DcMagicNumber,ExpirationTime,CLR_NONE);      
      }//if (BrokerIs2stageCrook)
      
      if (ticket > -1) 
      {
         // Opposite direction trade to scalp a few pips
         if (TakeOppositeDirectionTrades)
         {
            // Open the trade immediately
            if (TodtImmediate)
            {
               stoploss = 0;
               takeprofit=0;
               if (TodtSL > 0)
               {
                  stoploss = NormalizeDouble(MarketInfo(symbol, MODE_BID) - (TodtSL * point), digits);         
               }//if (TodSl > 0)
               if (TodtTP > 0)
               {
                  takeprofit=NormalizeDouble(MarketInfo(symbol,MODE_BID) + (TodtTP * point) + (spread * point), digits);
               }//if (DcTakeProfit > 0)
               if (!BrokerIs2stageCrook) ticket=OrderSendReliableMKT(symbol,OP_BUY,Lot,MarketInfo(symbol,MODE_ASK),10,stoploss,takeprofit,DailyCrossTradeComment + " ODT", DcMagicNumber,0,CLR_NONE);      
               if (BrokerIs2stageCrook) ticket=OrderSendReliable2Step(symbol,OP_BUY,Lot,MarketInfo(symbol,MODE_ASK),10,stoploss,takeprofit,DailyCrossTradeComment + " ODT", DcMagicNumber,0,CLR_NONE);      
               if (ticket < 0)
               {
                  int err=GetLastError();
                  Alert(Symbol(), " Opposite direction Buy order send failed with error(",err,"): ",ErrorDescription(err));
                  Print("Order send failed with error(",err,"): ",ErrorDescription(err));
                  return(false);
               }//if (ticket < 0)

            }//if (TodtImmediate)
         }//if (TakeOppositeDirectionTrades)
         
         return(true);
      }//if (ticket > -1) 
      else 
      {
         err = GetLastError();
         if (err == 4106) return(true); //Unknown symbol error
         else 
         {
            Alert(symbol, " DC Sell order send failed with error(",err,"): ",ErrorDescription(err));
            Print(symbol, " DC Sell order send failed with error(",err,"): ",ErrorDescription(err));
            return(false);
         }//else
      }
   }// End TakeShortDcTrade()

bool CheckLowerTimeFrames(string symbol, int GvVal)
{
   // A cross has occured, so the EA is waiting to place the trade. This routine checks the lower tf's.
   // Returns true if they all match up else false.
   // Passed param GvVal is the trade direction: 0=long; 1=short
   
   // Set up trigger index for reading and storing trigger strengths
  int TriggerIndex1, TriggerIndex2;
  double TriggerCurrencyA;
  double TriggerCurrencyB;
  string T1 = StringSubstr(symbol,0,3);// For extracting the index for KG RS GROUP
  string T2 = StringSubstr(symbol,4,3);
  
  if (T1 == "JPY") TriggerIndex1 = 1;
  if (T1 == "USD") TriggerIndex1 = 0;
  if (T1 == "GBP") TriggerIndex1 = 4;
  if (T1 == "EUR") TriggerIndex1 = 6;
  if (T1 == "CHF") TriggerIndex1 = 2;
  if (T1 == "AUD") TriggerIndex1 = 5;
  if (T1 == "NZD") TriggerIndex1 = 7;
  if (T1 == "CAD") TriggerIndex1 = 3;
   
  if (T2 == "JPY") TriggerIndex2 = 1;
  if (T2 == "USD") TriggerIndex2 = 0;
  if (T2 == "GBP") TriggerIndex2 = 4;
  if (T2 == "EUR") TriggerIndex2 = 6;
  if (T2 == "CHF") TriggerIndex2 = 2;
  if (T2 == "AUD") TriggerIndex2 = 5;
  if (T2 == "NZD") TriggerIndex2 = 7;
  if (T2 == "CAD") TriggerIndex2 = 3;
  

   
   if (LowerTimeFrameFilter1 > 0)
   {
      TriggerCurrencyA = iCustom(NULL,LowerTimeFrameFilter1, "KG RS GROUP V1.1",TriggerIndex1,0);
      TriggerCurrencyB = iCustom(NULL,LowerTimeFrameFilter1, "KG RS GROUP V1.1",TriggerIndex2,0);
      // Long trade
      if (GvVal == 0 && TriggerCurrencyA < TriggerCurrencyB) return(false);      
      //Short trade
      if (GvVal == 1 && TriggerCurrencyA > TriggerCurrencyB) return(false);
   }//if (LowerTimeFrameFilter1 > 0)
   
if (LowerTimeFrameFilter2 > 0)
   {
      TriggerCurrencyA = iCustom(NULL,LowerTimeFrameFilter2, "KG RS GROUP V1.1",TriggerIndex1,0);
      TriggerCurrencyB = iCustom(NULL,LowerTimeFrameFilter2, "KG RS GROUP V1.1",TriggerIndex2,0);
      // Long trade
      if (GvVal == 0 && TriggerCurrencyA < TriggerCurrencyB) return(false);      
      //Short trade
      if (GvVal == 1 && GvVal == 0 && TriggerCurrencyA > TriggerCurrencyB) return(false);
   }//if (LowerTimeFrameFilter2 > 0)
   
if (LowerTimeFrameFilter3 > 0)
   {
      TriggerCurrencyA = iCustom(NULL,LowerTimeFrameFilter3, "KG RS GROUP V1.1",TriggerIndex1,0);
      TriggerCurrencyB = iCustom(NULL,LowerTimeFrameFilter3, "KG RS GROUP V1.1",TriggerIndex2,0);
      // Long trade
      if (GvVal == 0 && TriggerCurrencyA < TriggerCurrencyB) return(false);      
      //Short trade
      if (GvVal == 1 && TriggerCurrencyA > TriggerCurrencyB) return(false);
   }//if (LowerTimeFrameFilter3 > 0)
   
if (LowerTimeFrameFilter4 > 0)
   {
      TriggerCurrencyA = iCustom(NULL,LowerTimeFrameFilter4, "KG RS GROUP V1.1",TriggerIndex1,0);
      TriggerCurrencyB = iCustom(NULL,LowerTimeFrameFilter4, "KG RS GROUP V1.1",TriggerIndex2,0);
      // Long trade
      if (GvVal == 0 && TriggerCurrencyA < TriggerCurrencyB) return(false);      
      //Short trade
      if (GvVal == 1 && TriggerCurrencyA > TriggerCurrencyB) return(false);
   }//if (LowerTimeFrameFilter1 > 0)
   

   // Got this far, so no reason to cancel the trade
   return(true);   
   
}// End bool CheckLowerTimeFrames(string symbol, int GvVal)

bool CheckIndividualLowerTF(string symbol, int GvVal, int TfVal)
{
   // Checks whether an individual lower tf matches up. Returns true if so, else false
   // GvVal is the trade directions: =-buy: 1=sell
   // TfVal is the tf in minutes
   
   // Set up trigger index for reading and storing trigger strengths
  int TriggerIndex1, TriggerIndex2;
  double TriggerCurrencyA;
  double TriggerCurrencyB;
  string T1 = StringSubstr(symbol,0,3);// For extracting the index for KG RS GROUP
  string T2 = StringSubstr(symbol,4,3);
  
  if (T1 == "JPY") TriggerIndex1 = 1;
  if (T1 == "USD") TriggerIndex1 = 0;
  if (T1 == "GBP") TriggerIndex1 = 4;
  if (T1 == "EUR") TriggerIndex1 = 6;
  if (T1 == "CHF") TriggerIndex1 = 2;
  if (T1 == "AUD") TriggerIndex1 = 5;
  if (T1 == "NZD") TriggerIndex1 = 7;
  if (T1 == "CAD") TriggerIndex1 = 3;
   
  if (T2 == "JPY") TriggerIndex2 = 1;
  if (T2 == "USD") TriggerIndex2 = 0;
  if (T2 == "GBP") TriggerIndex2 = 4;
  if (T2 == "EUR") TriggerIndex2 = 6;
  if (T2 == "CHF") TriggerIndex2 = 2;
  if (T2 == "AUD") TriggerIndex2 = 5;
  if (T2 == "NZD") TriggerIndex2 = 7;
  if (T2 == "CAD") TriggerIndex2 = 3;
  

   
   TriggerCurrencyA = iCustom(NULL,TfVal, "KG RS GROUP V1.1",TriggerIndex1,0);
   TriggerCurrencyB = iCustom(NULL,TfVal, "KG RS GROUP V1.1",TriggerIndex2,0);
   // Long trade
   if (GvVal == 0 && TriggerCurrencyA < TriggerCurrencyB) return(false);      
   //Short trade
   if (GvVal == 1 && TriggerCurrencyA > TriggerCurrencyB) return(false);


   // Got this far, so condition must be met
   return(true);

}// End bool CheckIndividualLowerTF(string symbol, int GvVal, int TfVal)

bool CheckTriggerGapSize(string symbol)
{
   // Compares the value of the two DC triggers prior to sending a trade. Returns true if the gap
   // is large enought, else returns false 
   
   // Set up trigger index for reading and storing trigger strengths
  int TriggerIndex1, TriggerIndex2;
  double TriggerCurrencyA;
  double TriggerCurrencyB;
  string T1 = StringSubstr(symbol,0,3);// For extracting the index for KG RS GROUP
  string T2 = StringSubstr(symbol,4,3);
  
  if (T1 == "JPY") TriggerIndex1 = 1;
  if (T1 == "USD") TriggerIndex1 = 0;
  if (T1 == "GBP") TriggerIndex1 = 4;
  if (T1 == "EUR") TriggerIndex1 = 6;
  if (T1 == "CHF") TriggerIndex1 = 2;
  if (T1 == "AUD") TriggerIndex1 = 5;
  if (T1 == "NZD") TriggerIndex1 = 7;
  if (T1 == "CAD") TriggerIndex1 = 3;
   
  if (T2 == "JPY") TriggerIndex2 = 1;
  if (T2 == "USD") TriggerIndex2 = 0;
  if (T2 == "GBP") TriggerIndex2 = 4;
  if (T2 == "EUR") TriggerIndex2 = 6;
  if (T2 == "CHF") TriggerIndex2 = 2;
  if (T2 == "AUD") TriggerIndex2 = 5;
  if (T2 == "NZD") TriggerIndex2 = 7;
  if (T2 == "CAD") TriggerIndex2 = 3;
  

   
   TriggerCurrencyA = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex1,0);
   TriggerCurrencyB = iCustom(NULL,0, "KG RS GROUP V1.1",TriggerIndex2,0);

   if (MathAbs(TriggerCurrencyA - TriggerCurrencyB) >= MinGapBetweenTriggers) return(true);
   else return(false);
   
}// End bool CheckTriggerGapSize(symbol)

void PrepareTradePlacement()
{
   // Cycles through the list of globals, sets up the appropriate pairs and trade direction,
   // then sends the trades.
   
   // Only continue if there are sufficient allowable trades left
   if (!OverrideMaxTradesAllowed && OrdersTotal() >= MaxTradesAllowed) return;
   
   // Cancel the trades failed GlobalVariable.
   // The OrderSend routine will replace it if a trade fails
   GlobalVariableDel("KgDcFailedTradesExist");
   
   for (int cc = 0; cc < GlobalVariablesTotal(); cc++)
   {
      string search = GlobalVariableName(cc);
      int index = StringFind(search, "PendingTrade");
      if (index > -1) // Pending trade gv
      {
         string symbol = StringConcatenate(StringSubstr(search, 4,6),PairSuffix);
         // Check trade does not already exist
         
         // Send trade if not, and delete the global that triggered the trade in the first place.
         bool TradeExists = DoesTradeExist(symbol);
         
         if (!TradeExists)
         {
            bool TradeAllowed = ReturnSpreadDecision(symbol); // Spread filter
            if (OrdersTotal() >= MaxTradesAllowed) TradeAllowed = false; //Max trades filter
            if (TradeAllowed)
            {
               int GvVal = GlobalVariableGet(search);// Trade direction
               TradeAllowed = CheckLowerTimeFrames(symbol, GvVal); // Lower tf filter
               if(TradeAllowed) TradeAllowed = CheckTriggerGapSize(symbol);// Gap between the two triggers
               if (TradeAllowed)
               {   
                  // Check Stoch valuse first, and end routine if overbought
                  if (UseStochasticFilter)
                  {
                     double StochVal = ReadStochastic(symbol);                     
                     if (GvVal == 0 && StochVal >= StochOverBought) TradeAllowed=false;
                     if (GvVal == 1 && StochVal <= StochOverSold) TradeAllowed=false;
                  }//if (UseStochasticFilter)
                  if (TradeAllowed)   
                  {
                     // Long trade = 0
                     // Short trade = 1
                     if (GvVal == 0) 
                     {   
                        if (TradeKgMethod) bool TradeSent = TakeLongDcTrade(symbol, OP_BUY);
                        if (TradeSaharsMethod) TradeSent = TakeLongDcTrade(symbol, OP_BUYSTOP);
                     }//if (GvVal == 0) 
                  
                     if (GvVal == 1) 
                     {
                        if (TradeKgMethod) TradeSent = TakeShortDcTrade(symbol, OP_SELL);
                        if (TradeSaharsMethod) TradeSent = TakeShortDcTrade(symbol, OP_SELLSTOP);
                     }//if (GvVal == 1) 
                  }//if (TradeAllowed)   
               }//if (TradeAllowed)   
            }//if (TradeAllowed)   
         }//if (!TradeExists)   
         if (TradeSent) 
         {
            GlobalVariableDel(search);
            cc--;
         }//if (TradeSent)
         else GlobalVariableSet("KgDcFailedTradesExist",0); // Tell the EA to keep on trying to send failed trades
      }//if (index > -1) // Pending trade gv
   }//for (int cc = 0; cc < GlobalVariablesTotal(); cc++)

}// End void PrepareTradePlacement()

bool ReturnSpreadDecision(string symbol)
{
   // Returns true if spread is <= user maximum, else returns false
   
   if (MarketInfo(symbol, MODE_SPREAD) <= MaximumSpread) return(true);
   else return(false);
   
}//End bool ReturnSpreadDecision(string symbol)

void SetUpCrossesDisplay()
{
   for (int cc = 0; cc < GlobalVariablesTotal(); cc++)
   {
      string search = GlobalVariableName(cc);
      int index = StringFind(search, "PendingTrade");
      if (index > -1) // Pending trade gv
      {
         int val = GlobalVariableGet(search);
         string type;
         if (val == 0) 
         {
            type = " Long";
            if (LowerTimeFrameFilter1 >0)
            {
               bool LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter1);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter1," ");
            }//if (LowerTimeFrameFilter1 >0) 
            if (LowerTimeFrameFilter2 >0)
            {
               LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter2);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter2," ");
            }//if (LowerTimeFrameFilter2 >0)
            if (LowerTimeFrameFilter3 >0)
            {
               LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter3);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter3," ");
            }//if (LowerTimeFrameFilter3 >0)
            if (LowerTimeFrameFilter4 >0)
            {
               LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter4);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter4," ");
            }//if (LowerTimeFrameFilter2 >0)            
         }//if (val == 0) 
         
         if (val == 1) 
         {
            type = " Short";
            if (LowerTimeFrameFilter1 >0)
            {
               LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter1);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter1," ");
            }//if (LowerTimeFrameFilter1 >0) 
            if (LowerTimeFrameFilter2 >0)
            {
               LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter2);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter2," ");
            }//if (LowerTimeFrameFilter2 >0) 
            if (LowerTimeFrameFilter3 >0)
            {
               LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter3);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter3," ");
            }//if (LowerTimeFrameFilter3 >0) 
            if (LowerTimeFrameFilter4 >0)
            {
               LowerTfOk = CheckIndividualLowerTF(StringSubstr(search, 4,6), val, LowerTimeFrameFilter4);
               if (LowerTfOk) type = StringConcatenate(type, " ", LowerTimeFrameFilter4," ");
            }//if (LowerTimeFrameFilter1 >0) 

         }//if (val == 0) 
         
         ScreenMessage = StringConcatenate(ScreenMessage,Gap,"     ",StringSubstr(search, 4,6),type);
         string symbol = StringConcatenate(StringSubstr(search, 4,6), PairSuffix);
         if (UseStochasticFilter)
         {
            double StochVal = ReadStochastic(symbol);
            ScreenMessage = StringConcatenate(ScreenMessage, " (Stochastic = ", StochVal, ")");
         }//if (UseStochasticFilter)
         
         if (UseMACD)
         {
            bool long = ReadMACD(OP_BUY, symbol);
            if (long) ScreenMessage = StringConcatenate(ScreenMessage, " (MACD = Long", ")");
            else  ScreenMessage = StringConcatenate(ScreenMessage, " (MACD = Short", ")");
         }//if (UseMACD)
                     
         if (UseShamusFamous)
         {
            long = ShamusFamousFilter(OP_BUY, symbol);
            if (long) ScreenMessage = StringConcatenate(ScreenMessage, " (UseShamusFamous = Long", ")");
            else  ScreenMessage = StringConcatenate(ScreenMessage, " (UseShamusFamous = Short", ")");
         }//if (UseMACD)
                     
         ScreenMessage = StringConcatenate(ScreenMessage," (spread = ", MarketInfo(symbol, MODE_SPREAD),")", NL);
         
      }//if (index > -1) // Pending trade gv
   }//for (int cc = 0; cc < GlobalVariablesTotal(); cc++)

}//void SetUpCrossesDisplay()

/*void CheckTradingTimes()
{
   // Sets the trading time filters


   
   IsAsianSession=false;
   IsLondonSession=false;
   IsNewYorkSession=false;

   int hours = TimeHour(TimeLocal());

   if (UseAsiaTimeFilter)
   {
      if (AsiaStartTime > AsiaEndTime)
      {
         if (hours >= AsiaStartTime || hours <= AsiaEndTime) IsAsianSession=true;         
      }//if (AsiaStartTime > AsiaEndTime)
      else if (hours >= AsiaStartTime && hours <= AsiaEndTime) IsAsianSession=true; 
   }//if (UseAsiaTimeFilter)

   if (UseLondonTimeFilter)
   {
      if (LondonStartTime > LondonEndTime)
      {
         if (hours >= LondonStartTime || hours <= LondonEndTime) IsLondonSession=true;
      }//if (LondonStartTime > LondonEndTime)   
      else if (hours >= LondonStartTime && hours <= LondonEndTime) IsLondonSession=true;
   }//if (UseLondonTimeFilter)

   if (UseNewYorkTimeFilter)
   {
      if (LondonStartTime > LondonEndTime)
      {
         if (hours >= NewYorkStartTime || hours <= NewYorkEndTime) IsNewYorkSession=true;
      }//if (LondonStartTime > LondonEndTime)
      else if (hours >= NewYorkStartTime && hours <= NewYorkEndTime) IsNewYorkSession=true;
   }//if (UseLondonTimeFilter)


}// End void CheckTradingTimes()
*/
void BreakEvenStopLoss() 
{
   // Move stop loss to breakeven
   
   bool result;

           
   if (OrderType()==OP_BUY)
         {
            if (bid >= OrderOpenPrice () + (point*BreakEvenPips) && 
                OrderStopLoss()<OrderOpenPrice())
            {
               result = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(BreakEvenProfit*point),OrderTakeProfit(),0,CLR_NONE);
               if (!result)
               {
                  int err=GetLastError();
                  if (ShowAlerts) Alert("Break even attempt failed for ticket no ", OrderTicket(), " with error(",err,"): ", ErrorDescription(err));
                  Print("Break even attempt failed for ticket no ", OrderTicket(), " with error(",err,"): ", ErrorDescription(err));
               }//if (!result)
               if (result && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
            }
   	   }               			         
          
   if (OrderType()==OP_SELL)
         {
           if (ask <= OrderOpenPrice() - (point*BreakEvenPips) &&
              (OrderStopLoss()>OrderOpenPrice()|| OrderStopLoss()==0)) 
            {
               result = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(BreakEvenProfit*point),OrderTakeProfit(),0,CLR_NONE);
               if (!result)
               {
                  err=GetLastError();
                  if (ShowAlerts) Alert("Break even attempt failed for ticket no ", OrderTicket(), " with error(",err,"): ", ErrorDescription(err));
                  Print("Break even attempt failed for ticket no ", OrderTicket(), " with error(",err,"): ", ErrorDescription(err));
               }//if (!result)
               if (result && ShowAlerts==true) Alert("Breakeven set on ", OrderSymbol(), " ticket no ", OrderTicket());
            }    
         }
      

} // End BreakevenStopLoss sub

bool PartCloseTradeFunction()
{
   // Called when any attempt to part-close a long trade is needed.
   // Trade has already been selected 
   // Returns 'true' if succeeds, else false, after setting a global variable to tell
   // the basket monitoring function that a closure failed and needs to be attempted
   // again.
   
   double price;
   if (OrderType()==OP_BUY) price = bid;
   if (OrderType()==OP_SELL) price = ask;
   
         
   bool result=OrderCloseReliableMKT(OrderTicket(), Close_Lots, price, 3, CLR_NONE);
      if (!result)
      {
         if (ShowAlerts==true) Alert("Partial close of ", OrderSymbol(), " ticket no ", OrderTicket());
         return(true);
      }
      else
      {
         if (ShowAlerts==true) Alert("Partial close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed");
         return(false);
      }                          
   
}// End bool PartCloseTradeFunction()
   
void JumpingStopLoss() 
{
   // Jump sl by pips and at intervals chosen by user .
   // Also carry out partial closure if the user requires this

   // Abort the routine if JumpAfterBreakevenOnly is set to true and be sl is not yet set
   if (JumpAfterBreakevenOnly && OrderType()==OP_BUY)
   {
      if(OrderStopLoss()<OrderOpenPrice()) return(0);
   }
  
   if (JumpAfterBreakevenOnly && OrderType()==OP_SELL)
   {
      if(OrderStopLoss()>OrderOpenPrice()) return(0);
   }
  
   int ticket;
   double sl=OrderStopLoss(); //Stop loss

   if (OrderType()==OP_BUY)
   {
      // First check if sl needs setting to breakeven
      if (sl==0 || sl<OrderOpenPrice())
      {
         if (ask >= OrderOpenPrice() + (JumpingStopPips*point))
         {
            sl=OrderOpenPrice();
            if (AddBEP==true) sl=sl+(BreakEvenProfit*point); // If user wants to add a profit to the break even
            if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
            {
               if (ShowAlerts==true) Alert("Jumping stop set at breakeven ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
               Print("Jumping stop set at breakeven: ", OrderSymbol(), ": SL ", sl, ": Ask ", ask);
               if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               {
                  bool PartCloseSuccess = PartCloseTradeFunction();
                  if (!PartCloseSuccess) SetAGlobalTicketVariable();
               }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))                        
            return(0);
         }//if (ask >= OrderOpenPrice() + (JumpingStopPips*point))
      } //close if (sl==0 || sl<OrderOpenPrice()
   
      // Increment sl by sl + JumpingStopPips.
      // This will happen when market price >= (sl + JumpingStopPips)
      if (bid>= sl + ((JumpingStopPips*2)*point) && sl>= OrderOpenPrice())      
      {
         sl=sl+(JumpingStopPips*point);
         if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
         {
            if (ShowAlerts==true) Alert("Jumping stop set at ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": Ask ", ask);
            if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
            {
               PartCloseSuccess = PartCloseTradeFunction();
               if (!PartCloseSuccess) SetAGlobalTicketVariable();
            }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
         }//if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
      }// if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())      
   }//if (OrderType()==OP_BUY)
   
   if (OrderType()==OP_SELL)
   {
        // First check if sl needs setting to breakeven
      if (sl==0 || sl>OrderOpenPrice())
      {
         if (ask <= OrderOpenPrice() - (JumpingStopPips*point))
         {
            if (AddBEP==true) sl=sl-(BreakEvenProfit*point); // If user wants to add a profit to the break even
            if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))
            {
               if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               {
                  PartCloseSuccess = PartCloseTradeFunction();
                  if (!PartCloseSuccess) SetAGlobalTicketVariable();
               }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE))

            sl=OrderOpenPrice();
            if (AddBEP==true) sl=sl-(BreakEvenProfit*point); // If user wants to add a profit to the break even
            ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (ticket>0)
            {
               if (ShowAlerts==true) Alert("Jumping stop set at breakeven ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
               Print("Jumping stop set at breakeven: ", OrderSymbol(), ": SL ", sl, ": Ask ", ask);
               if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
               {
                  PartCloseSuccess = PartCloseTradeFunction();
                  if (!PartCloseSuccess) SetAGlobalTicketVariable();
               }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
            }//if (ticket>0)            
            return(0);
         }//if (ask <= OrderOpenPrice() - (JumpingStopPips*point))
      } // if (sl==0 || sl>OrderOpenPrice()
   
      // Decrement sl by sl - JumpingStopPips.
      // This will happen when market price <= (sl - JumpingStopPips)
      if (bid<= sl - ((JumpingStopPips*2)*point) && sl<= OrderOpenPrice())      
      {
         sl=sl-(JumpingStopPips*point);
         ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (ticket>0)
         {
            if (ShowAlerts==true) Alert("Jumping stop set at ",sl, " ", OrderSymbol(), " ticket no ", OrderTicket());
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": Ask ", ask);
            if (PartCloseEnabled && OrderLots() > Preserve_Lots)// Only try to do this if the jump stop worked
            {
               PartCloseSuccess = PartCloseTradeFunction();
               if (!PartCloseSuccess) SetAGlobalTicketVariable();
            }//if (PartCloseEnabled && OrderLots() > Preserve_Lots)
         }//if (ticket>0)          
      }// close if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

} //End of JumpingStopLoss sub

int GetNextAvailableVariableNumber()
{
   // Called from the SetAGlobalTicketVariable() function.
   // Returns the first integer available.
   // The globla variable name consists of "GlobalVariableTicketNo" (stored in the 
   // string TicketName) and an integer.
         
   if (GlobalVariablesTotal()==0) return(1);
   
   for (int cc=1; cc > -1; cc++)
   {
      string ThisGlobalName = StringConcatenate(TicketName,DoubleToStr(cc,0));
      double v1 = GlobalVariableGet(ThisGlobalName);
      if(v1==0) return(cc);
      if (cc>100) return;
   }
   
}//End int GetNextAvailableVariableNumber()   

void SetAGlobalTicketVariable()
{
   // Called whenever an attempt to part-close a trade fails.
   // This function finds the first available global variable name and sets up 
   // a gv with the ticket number of the offending trade. These gv's will consist of
   // the string TicketName ("GlobalVariableTicketNo") and an integer
   int cc = GetNextAvailableVariableNumber();
   string GlobalName=StringConcatenate(TicketName,DoubleToStr(cc,0));
   GlobalVariableSet(GlobalName, OrderTicket());
   GlobalVariablesExist=true;
   
} // End void SetAGlobalTicketVariable();


void TrailingStopLoss()
{
   int ticket;
   double sl=OrderStopLoss(); //Stop loss
   double BuyStop=0, SellStop=0;
   
   if (OrderType()==OP_BUY) 
      {
		   if (bid >= OrderOpenPrice() + (TrailingStopPips*point))
		   {
		       if (bid > sl +  (TrailingStopPips*point))
		       {
		          sl= bid - (TrailingStopPips*point);
		          // Exit routine if user has chosen StopTrailAtPipsProfit and
		          // sl is past the profit point already
		          if (StopTrailAtPipsProfit && sl>= OrderOpenPrice() + (StopTrailPips*point)) return;
		          ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
               if (ticket>0)
               {
                  Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Ask ", ask);
               } 
		       }
		   }
      }

   if (OrderType()==OP_SELL) 
      {
		   if (ask <= OrderOpenPrice() - (TrailingStopPips*point))
		   {
		       if (ask < sl -  (TrailingStopPips*point))
		       {
	               sl= ask + (TrailingStopPips*point);
  	               // Exit routine if user has chosen StopTrailAtPipsProfit and
		            // sl is past the profit point already
		            if (StopTrailAtPipsProfit && sl<= OrderOpenPrice() - (StopTrailPips*point)) return;
		            ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
                  if (ticket>0)
                  {
                     Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Bid ", bid);
                  } 
		       }
		   }
      }


} // End of TrailingStopLoss sub
   
void InstantTrailingStopLoss()
/* This is the same as TrailingStopLoss, except that it moves the sl as soon as
 the market moves ion favour of the trade. 
 It will set an initial sl of market price +- UtsPips, depending on the type of trade,
 then move it every time the market moves in favour of the trade. It will therefore override
 any user set sl on the trade.
 Market price +- UtsPips will result in breakeven, and move into profit after that.
*/ 
{
   int ticket;
   double sl=OrderStopLoss(); //Stop loss
   double BuyStop=0, SellStop=0;
   
   if (OrderType()==OP_BUY) 
      {
		   if (bid >= sl+(InstantTrailingStopPips*point)) // Has to overcome the spread first
		   {
	         sl= bid - NormalizeDouble((InstantTrailingStopPips*point),digits);
	         if (sl <= OrderStopLoss()) return(0);
	         if (StopInstantTrailAfterBreakEven && sl>OrderOpenPrice()) return(0); // cancel instant trail after breakeven
	         // Exit routine if user has chosen StopTrailAtPipsProfit and
            // sl is past the profit point already
            if (StopInstantTrailAtPipsProfit && sl>= OrderOpenPrice() + (StopInstantTrailPips*point)) return;
		          
	         ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (ticket>0)
            {
               Print("Instant trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Ask ", ask);
            } 
		    return;
		    }
      }

      if (OrderType()==OP_SELL) 
      {
	       if ((ask <= sl - (InstantTrailingStopPips*point)) || sl==0)
	       {
	            sl= ask + NormalizeDouble((InstantTrailingStopPips*point),digits);
   	         if (StopInstantTrailAfterBreakEven && sl<OrderOpenPrice()) return(0); // cancel instant trail after breakeven
               // Exit routine if user has chosen StopTrailAtPipsProfit and
	            // sl is past the profit point already
	            if (StopInstantTrailAtPipsProfit && sl<= OrderOpenPrice() - (StopInstantTrailPips*point)) return;
	            ticket = OrderModifyReliable(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
               if (ticket>0)
               {
                  Print("Trailing stop updated: ", OrderSymbol(), ": SL ", sl, ": Bid ", bid);
               } 
            return;   
	       }		   
      }


} // End of InstantTrailingStopLoss() sub


void TryPartCloseAgain()
{
   // Called if GlobalVariablesExist is set to true and global variables exist.
   // Attempts to part-close where a previous attempt failed
   
   string name;
   int index;
   int TicketNumber;
   for (int cc=0; cc < GlobalVariablesTotal(); cc++)
   {
      name = GlobalVariableName(cc);// Extract gv name
      index = StringFind(name,"GlobalVariableTicketNo",0);// Is it relevent to this function?
      if (index>-1)// If so, then retry the part-close
      {
         TicketNumber = GlobalVariableGet(name);
         //Make sure trade was not closed previously
         if (OrderSelect(TicketNumber, SELECT_BY_TICKET) && OrderCloseTime() == 0)
         {
            bool PartCloseSuccess = PartCloseTradeFunction();
            if (PartCloseSuccess)
            {
               GlobalVariableDel(name);
               cc--;
            }//if (PartCloseSuccess)
         }//if (OrderSelect(), TicketNumber, SELECT_BY_POS)
         else
         {
            GlobalVariableDel(name);
            cc--;
         }
      }//if (index>-1)
   }//for (int cc=0; cc < GlobalVariablesTotal(); cc++)
}//End void TryPartCloseAgain()

void ManageTrade()
{
     
   // Call the working subroutines one by one. 

   // Global variable to pick up on failed part-closes
   if (GlobalVariablesTotal()>0) GlobalVariablesExist=true;
   if (GlobalVariablesExist && GlobalVariablesTotal()>0)  TryPartCloseAgain();
   if (GlobalVariablesExist && GlobalVariablesTotal()==0) GlobalVariablesExist=false;
      
   // Breakeven
   if(BreakEven) BreakEvenStopLoss();
   
   // JumpingStop
   if(JumpingStop) JumpingStopLoss();
   
   // TrailingStop
   if(TrailingStop) TrailingStopLoss();

   // Trailing stop loss that moves as soon as the market moves in the direction of the trade.
   if (InstantTrailingStop) InstantTrailingStopLoss();

   // Check pending trades. Adjust their fill price if the market has moved sufficiently
   if (OrderType() > 1) CheckPendingTradeEntryLevel();

   // Global order closure for DC method
   if (DcGlobalOrderClosureEnabled && OrdersTotal() >0) DcGlobalOrderClosure();
   

   

   // Hedge trade
   //if (HeadgeEnabled) HedgeTrade();

   
   
} // End of ManageTrade()


void MonitorTrades()
{
   // This is a cut down version of MPTM and works the same way.
   
   for (int cnt=OrdersTotal(); cnt >= 0; cnt++)
   { 
      if (!OrderSelect(cnt, SELECT_BY_POS)) continue;
      if (OrderMagicNumber() == DcMagicNumber) // Continue if order is correct symbol or the ea is to manage all trades regardless
      {
         // Set up bid and ask so the program can use them to calculate jumping stops, be's etc
         bid = MarketInfo(OrderSymbol(), MODE_BID);           
         ask = MarketInfo(OrderSymbol(), MODE_ASK);
         point = MarketInfo(OrderSymbol(), MODE_POINT);
         digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
         
         
         // Is this trade being managed by the ea?
         if (EaManagesTrades) ManageTrade(); // The subroutine that calls the other working subroutines
         
      } // Close if (OrderSymbol()==Symbol())
      
   
   } // Close For loop

}// End void MonitorTrades()

/*bool CheckDcTrade(string symbol, bool TradeAllowed, string TradeType)
{
   // Returns true or false as appropriate. 
   // Compares the relative strength of the passed pair on a higher tf.
   
   if(!TradeAllowed) return(TradeAllowed);//Nothing to do
   
   // Isolate the triggers within each pair
   string symbol1 = StringSubstr(symbol, 0,3);
   string symbol2 = StringSubstr(symbol, 3,3);   
   int PairNo1;
   int PairNo2;
   double Strength1;
   double Strength2;
   
   if (symbol1 == "JPY")  PairNo1 = 1;
   if (symbol1 == "USD")  PairNo1 = 0;
   if (symbol1 == "GBP")  PairNo1 = 4;
   if (symbol1 == "EUR")  PairNo1 = 6;
   if (symbol1 == "CHF")  PairNo1 = 2;
   if (symbol1 == "AUD")  PairNo1 = 5;
   if (symbol1 == "NZD")  PairNo1 = 7;
   if (symbol1 == "CAD")  PairNo1 = 3;
   
   if (symbol2 == "JPY")  PairNo2 = 1;
   if (symbol2 == "USD")  PairNo2 = 0;
   if (symbol2 == "GBP")  PairNo2 = 4;
   if (symbol2 == "EUR")  PairNo2 = 6;
   if (symbol2 == "CHF")  PairNo2 = 2;
   if (symbol2 == "AUD")  PairNo2 = 5;
   if (symbol2 == "NZD")  PairNo2 = 7;
   if (symbol2 == "CAD")  PairNo2 = 3;
   
   
   
   Strength1 = iCustom(NULL,KgFilterMins, "KG RS GROUP V1.1",PairNo1,0);
   Strength2 = iCustom(NULL,KgFilterMins, "KG RS GROUP V1.1",PairNo2,0);

   // "Strong" means buying first pair in string, so strength must be higher than second pair
   if (TradeType == "Buy")
   {
      if (Strength1 > Strength2) return(true);
      else return(false);
   }//if (BasketType == "Strong");
   
   // "Weak" means selling first pair in string, so strength must be lower than second pair
   if (TradeType == "Sell")
   {
      if (Strength1 < Strength2) return(true);
      else return(false);
   }//if (BasketType == "Weak");
   
   
}//bool CheckDcTrade(string symbol, bool TradeAllowed, string BasketType)
*/

/*void CheckForReCrosses()
{
   //Deletes pending gv's when there has been a re-cross
   
   for (int cc=0; cc<GlobalVariablesTotal(); cc++)
   {
      string GvName = GlobalVariableName(cc);
      int index = StringFind(GvName, "PendingTrade");
      string symbol = StringSubstr(GvName,4,6);
      bool RetainGlobal=false;
      
      if (index > -1) // Pending trade gv
      {
         int TradeDirection = GlobalVariableGet(GvName);
         // Check pending buys
         if (TradeDirection == 0)
         {
            RetainGlobal = CheckDcTrade(symbol, true, "Buy");
         }//if (TradeDirection == 0)
         
         // Check pending sells
         if (TradeDirection == 1)
         {
            RetainGlobal = CheckDcTrade(symbol, true, "Sell");
         }//if (TradeDirection == 1)
         
         if (!RetainGlobal) 
         {
            GlobalVariableDel(GvName);
            cc--;
         }//if (!RetainGlobal) 
      }//if (index > -1)
      
   }//for (int cc=0; cc<GlobalVariablesTotal(); cc++)
      
}//End void CheckForReCrosses()
*/

bool CloseDcTrades(int MagicNumber)
{
   // Attempts to close all DC method trades.
   // Returns true if all trades were closed, else returns false
   
   bool result=true;// Set to false if a closure fails
   
   for (int cc = OrdersTotal(); cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderMagicNumber()==MagicNumber)      
      {
         if (OrderType()==OP_BUY)
         {
            bool ticket=OrderCloseReliableMKT(OrderTicket(),OrderLots(), MarketInfo(OrderSymbol(), MODE_BID),10,CLR_NONE);
            if (!ticket) result=false;
            else cc++;
         }//if (OrderType()==OP_BUY)   
         
         if (OrderType()==OP_SELL)
         {
            ticket=OrderCloseReliableMKT(OrderTicket(),OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK),10,CLR_NONE);
            if (!ticket) result=false;
            else cc++;
         }//if (OrderType()==OP_SELL)   
         
      }//if (OrderMagicNumber()==MagicNumber)
   }//for (int cc = OrdersTotal(); cc > 0 ; cc--)

   return(result);
   
}// End bool CloseDcTrades(MagicNumber)

void DcTradesTotal()
{
   // Calculates the number of DC trades open and their profit. Used for display and global closure purposes
   
   DcProfit=0;
   DcTradesOpen=0;
   
   if (OrdersTotal() == 0) return;//Nothing to do
   
   for (int cc = 0; cc < OrdersTotal(); cc++)
   {
      if(!OrderSelect(cc, SELECT_BY_POS)) continue;
      if (OrderMagicNumber() == DcMagicNumber)
      {
         DcProfit = DcProfit + OrderProfit();
         DcTradesOpen++;
      }//if (OrderMagicNumber == DcMagicNumber)
   }//for (int cc = 0; cc < OrdersTotal(); cc++)

}//void DcTradesTotal()

void DcGlobalOrderClosure()
{
   bool CloseOrders=false;
   double ProfitPercentage=0;
   
   // Calculate the DcProfit. This function is only called if there are open trades
   DcTradesTotal();
   
   // First calculate whether the upl is >= the point at which the position is to close

   // Profit in dollars enabled
   if (DcProfitInDollars)
   {
      if(DcProfit >= DcDollarProfit) CloseOrders=true;
   }
   
   // Profit as percentage of account balance enabled
   if (DcProfitAsPercentageOfBalance)
   {
      ProfitPercentage=AccountBalance() * (DcPercentageProfit/100);
      if (DcProfit >= ProfitPercentage) CloseOrders=true;
   }

   // Abort routine if profit has not hit the required level
   if (!CloseOrders) return(0);
   
   // Got this far, so orders are to be closed.
   bool CloseTrades = CloseDcTrades(DcMagicNumber);
   if (!CloseTrades) CloseAllDcTrades = true;// Closure failed, so force a retry at the next tick
   
   // User feedback
   if (ShowAlerts) Alert("Global profit hit your target, so all open trades should have been closed");
   
} //End of DcGlobalOrderClosure()



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
    if (!EaUseAllowed) return;
    
    DcTradesTotal();// For display and global closure routines
   
   // Global DC trade close failure?
   if (CloseAllDcTrades)
   {
      CloseDcTrades(DcMagicNumber);
      return;
   }//if (CloseAllDcTrades)
   
      
   // Manage existing trades using routines taken from MPTM
   if (OrdersTotal() > 0 && EaManagesTrades) MonitorTrades();
   
   //if (GlobalVariablesTotal() > 0) CheckForReCrosses();
   
   bool TimeOk=true;
   // Trading time filters
   // Sunday candle   
   if (!TradeSundayCandle && TimeDayOfWeek(TimeLocal())==0) TimeOk=false;
   
   //Monday start
   if (TimeDayOfWeek(TimeLocal())==1 && TimeHour(TimeLocal()) < MondayStartHour) TimeOk=false;
   //Friday shut down
   if (StopTradingOnFriday)
   {
      if (TimeDayOfWeek(TimeLocal())==5)
      {   
         if (TimeHour(TimeLocal()) >= FridayStopHour)
         {
            TimeOk=false;
         }//if (TimeHour(TimeCurrent()) >= FridayStopHour)   
      }//if TimeDayOfWeek(TimeCurrent()==5)   
   }//if (StopTradingOnFriday)

   if (TimeOk) CheckForCrosses(); // Checks for crosses and sets up globals to tell the EA to send trades at the next candle
   DisplayUserFeedback();


   //Is this a new day?. If so, check for trade placements.
   if (!OverrideMaxTradesAllowed && OrdersTotal() >= MaxTradesAllowed) return; // Will not allow extra trades
   
   // Place trades if appropriate
   if (TimeOk) PrepareTradePlacement();


//----
   return(0);
  }
//+------------------------------------------------------------------+